unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Buttons;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses base64;

function StreamToBase64(const AStream: TMemoryStream; out Base64: String): Boolean;
var
  Str: String;
begin
  Result := False;
  if AStream.Size = 0 then
    Exit;
  AStream.Position := 0;
  try
    SetLength(Str, AStream.Size div SizeOf(Char));
    AStream.ReadBuffer(Pointer(Str)^, AStream.Size div SizeOf(Char));
    Base64 := EncodeStringBase64(Str);
    Result := Length(Base64) > 0;
  except
    on E: Exception do
      ShowMessage(E.Message);
  end;
end;

function Base64ToStream(const ABase64: String; var AStream: TMemoryStream): Boolean;
var
  Str: String;
begin
  Result := False;
  if Length(Trim(ABase64)) = 0 then
    Exit;
  try
    Str := DecodeStringBase64(ABase64);
    AStream.Write(Pointer(Str)^, Length(Str) div SizeOf(Char));
    AStream.Position := 0;
    Result := AStream.Size > 0;
  except
    on E: Exception do
      ShowMessage(E.Message);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Ms: TMemoryStream;
  Png: TPortableNetworkGraphic;
begin
  Ms := TMemoryStream.Create;
  try
    if Base64ToStream(Memo1.Text, MS) then
    begin
      Png := TPortableNetworkGraphic.Create;
      try
        Png.LoadFromStream(Ms);
        Image1.Canvas.Draw(0, 0, Png);
      finally
        Png.Free;
      end;
    end;
  finally
    Ms.Free;
  end;
end;



end.

